Elisei Alexandru
333CC

PONG
====


Wiki
----

Pagina de wiki a jocului se găsește la adresa:
[wiki](http://cs.curs.pub.ro/wiki/pm/prj2017/aaldescu/elisei.alexandru).

Aici se găsesc și informații legate de componentele hardware ale proiectului.


Descriere
---------

Jocul Pong este un joc 2D care simulează un joc de tenis de masă. Se joacă cu
doi jucători și fiecare jucător are la dispoziție o paletă cu care încearcă să
lovească o minge ce ricoșeaza de la un jucător la altul. Jucătorul ce nu
reușește să lovească mingea și ea trece de paleta lui a pierdut.

Jocul se poate juca atât în module single player cât și multiplayer.

De asemenea, în timpul jocului este redată muzica de la Mario, care poate fi
oprită făcând cu mâna deasupra senzorului de lumină.


Implementare
------------

Am implementat jocul in fișierul main.c. Jocul este un automat finit cu
următoarele stări: SINGLE_PLAYER_MODE, MULTI_PLAYER_MODE, MENU_MODE. În funcție
de starea curentă butoanele jocului îndeplinesc funcții diferite:

- în MENU_MODE: butonul BACK reia jocul, butonul SELECT activează optiunea
  curentă, butoanele player 1 sus si jos deplaseaza cursorul sus, respectiv
  jos.

- în SINGLE_PLAYER_MODE: butoanele SELECT și butoanele jucătorul 2 sunt
  dezactivate. Butonul BACK activează meniul.

- în MULTI_PLAYER_MODE: butonul SELECT este dezactivat și BACK activează meniul.

Ecranul este reîmprospătat la fiecare 30 milisecunde (refresh rate de 33 Hz).
Pentru a crește/scădea viteza cu care se mișca obiectele pe ecran am implementat
un contor pentru fiecare buton care se decrementează la fiecare refresh al
ecranului. Când devine 0, acțiunea asociată obiectului este efectuată. Astfel
pot sa controlez individual viteza cu care se mișcă bila sau paletele
jucătorilor.

Am folosit un display de Nokia de 3310/5110 pentru joc. Am scris propria mea
bibliotecă pentru controller-ul PCD8544 folosind datasheet-ul (fișierele
PCD8544.h și PCD8544.c). Fontul folosit pentru display este de asemenea creat de
mine și este implementat în fișierul charmap.h.

Redarea muzicii din Mario este implementată în fișierele music.h și music.c. Am
folosit două timere: unul creeaza semnal PWM pe pinul PB4 cu duty cycle 50% și
frecvența variabilă în funcție de frecvența notei care este redată și care
controlează buzzer-ul. Al doilea timer modifică frecvența semnalului PWM la
terminarea redării notei curente. Acest timer folosește întreruperi pentru a
seta frecvența semnalului PWM.

Muzica se oprește din redat atunci când se face cu mâna deasupra unui
fotorezistor. Pentru a detecta mișcarea mâinii am folosit o fotorezistență în
serie cu o rezistență legată la GND pentru a realiza un divizor rezistiv. La
lumina fotorezistența are a o valoare mică și pinul de ADC va măsura o tensiune
apropiată de cea de referință. La întuneric fotorezistența va avea o valoare
mare și tensiunea măsurată de ADC va fi mai mică. Detectarea mișcării mâinii
se face în doi pași: mai întâi se detectează mâna deasupra fotorezistenței
(tensiune mică), apoi se așteaptă să se ridice mâna (tensiune mare). Am folosit
acest sistem pentru a preveni situații în care se ține mâna deasupra
fotorezistenței și melodia se oprește apoi se pornește în mod repetat. Detecția
mișcării este implementată în fișierele adc.h și adc.c.
