#ifndef USART_H_
#define USART_H_

#include <stdint.h>

/*
 * Start USART0 in a 8N1 (8 data bits, no parity, one stop bit) configuration.
 *
 * The TXD0 and RXD0 pins will be configured accordingly.
 */
void USART0_8N1_init(int32_t baud);

void USART0_transmit(char data);

void USART0_puts(const char data[]);

char USART0_receive();

/*
 * Start USART1 in a 8N1 (8 data bits, no parity, one stop bit) configuration.
 *
 * The TXD1 and RXD1 pins will be configured accordingly.
 */
void USART1_8N1_init(int32_t baud);

void USART1_transmit(char data);

void USART1_puts(const char data[]);

char USART1_receive();

#endif
